---
- name: Include download tasks
  ansible.builtin.import_tasks: download.yml

- name: Extract
  when: fme_flow_extract_command_enabled
  block:
    - name: "Extract to {{ fme_flow_extraction_path }}"
      ansible.windows.win_command:
        cmd: "{{ fme_flow_extract_command }}"
        creates: >-
          {{ fme_flow_installer_path_msi
          | c2platform.core.replace_slashes }}
      failed_when: false  # extract has a randomized exit code
      register: fme_flow_extract_command_result

    - name: Stat MSI
      ansible.windows.win_stat:
        path: "{{ fme_flow_installer_path_msi }}"
      register: fme_flow_installer_path_msi_results

    - name: Fail if the MSI file doesn't exist
      ansible.builtin.fail:
        msg: >-
          The installer MSI file was not found at {{ fme_flow_installer_path_msi }}.
          Extraction of the MSI file failed.
      when: not fme_flow_installer_path_msi_results.stat.exists

- name: Install FME Flow
  ansible.windows.win_package:
    path: >-
      {{ fme_flow_installer_path_msi
      | c2platform.core.replace_slashes }}
    state: present
    arguments: "{{ fme_flow_install_command }}"
  become: true
  become_method: ansible.builtin.runas
  become_flags: logon_type=new_credentials logon_flags=netcredentials_only
  vars:
    ansible_become_user: "{{ fme_flow_svcaccount }}"
    ansible_become_password: "{{ fme_flow_svcpassword }}"
    # ansible_become: true
    # ansible_become_method: runas
    # ansible_become_user: DOMAIN\user
    # ansible_become_password: Password01
    # ansible_become_flags: logon_type=new_credentials logon_flags=netcredentials_only
  when: fme_flow_install_command_enabled
  ignore_errors: "{{ fme_flow_install_command_ignore_errors }}"
  register: fme_flow_install_command_result

- name: Restart Tomcat service after FME installation
  ansible.windows.win_service:
    name: "{{ fme_flow_include_role_tomcat['service'] }}"
    state: restarted
  when: fme_flow_include_role_tomcat['include']

- name: "Create {{ fme_flow_install_command_result_yml }}"
  ansible.windows.win_copy:
    content: >-
      {{ fme_flow_install_command_result | to_nice_yaml }}
    dest: "{{ fme_flow_install_command_result_yml }}"
  when: fme_flow_install_command_ignore_errors
# TODO
# - name: Delete content & directory
#   ansible.windows.win_file:
#     state: absent
#     path: 'D:\temp\install\FMEflow'


## =================================================================== ##

- name: Create local firewall rule outbound
  community.windows.win_firewall_rule:
    name: "FME_out_{{ item }}"
    localport: "{{ item }}"
    program: any
    direction: out
    action: allow
    protocol: tcp
    state: present
    enabled: true
  with_items: "{{ fme_flow_outbound_localport }}"

- name: Create local firewall rule inbound
  community.windows.win_firewall_rule:
    name: "FME_in_{{ item }}"
    localport: any
    program: any
    direction: in
    action: allow
    protocol: tcp
    state: present
    enabled: true
  with_items: "{{ fme_flow_inbound_localport }}"

# TODO (nice to have) Proxy toevoegen aan fme flow instellingen/config file (fme flow snapt machine proxy niet)
